//Jetzt werden die Sesnorwerte nicht mehr aus Farbpixeln gewonnen, sondern geometrisch,
//was eine Offline-Simulation (ohne Visualisierung) ermöglicht.
import java.util.Random;

float SENSOR_FLOAT = 0.0f;

float Rbahn = 250;
float bahnbreite = 40;

float v = 40;
float phi = PI/4;
float x = 0;
float y = 0;
float dt = 1.0/30.0;

public Auto auto;

//Neuronales Netz
float[] w = new float[20];   //Alle Gewichte des Neuronalen Netzes
float[] out = new float[5];  //Ausgänge der 5 Neuronen des Neuronalen Netzes
Random zufall = new Random(System.currentTimeMillis());
// siehe Funktion "regeln(..)"

public void setup()
{
    for(int i=0;i<w.length;i++)
        w[i] = 2000.0f*(zufall.nextFloat() -0.5f)  ; // Zufallswerte zwischen ]-1000,+1000[
  
    auto = new Auto(x,-height/2+bahnbreite,phi,v);
  
    size(600,600);
    frameRate(1.0/dt);
}

public void draw()
{   
     translate(width/2, height/2);
     scale(1.0,-1.0);
     background(0);
          
     noStroke();
     fill(255);
     ellipse(0,0,2*Rbahn+bahnbreite,2*Rbahn+bahnbreite);
     fill(0);
     ellipse(0,0,2*Rbahn-bahnbreite,2*Rbahn-bahnbreite);
     
     auto.draw();
     auto.drawSensorwerte();
     
     auto.zeitschritt(dt);
     
     auto.setOmega(regeln(auto.sensorwerte));
}

public void keyPressed()
{
        if (key == CODED) 
        {
            if (keyCode == LEFT) 
            {
                phi+=PI/16.0;
                auto.setPhi(phi);
            } 
            else if (keyCode == RIGHT) 
            {
                phi-=PI/16.0;
                auto.setPhi(phi);
            } 
        }
  
}